# SKU搜索系统

这是一个基于Gradio构建的SKU（库存单位）搜索和管理系统，提供商品信息搜索、PDF文件解析、商品卖点生成等功能。

## 功能特性

- **商品信息搜索**：通过商品ID快速查询商品详细信息，包括商品图片、价格、颜色、成分、卖点和细节
- **PDF文件解析**：支持上传PDF文件并解析其中的商品信息
- **商品卖点生成**：基于商品ID和图片自动生成中英文卖点描述
- **卖点标题生成**：根据商品ID和描述生成中英文标题

## 系统要求

- Python 3.x
- 操作系统：Windows/Linux/MacOS

## 安装步骤

1. 克隆项目到本地：

```bash
git clone [项目地址]
cd sku_search
```

2. 安装依赖包：

```bash
pip install -r requirement.txt
```

## 使用方法

1. 启动服务：

```bash
python sku_search.py
```

## 主要功能说明

### 商品信息搜索
- 输入商品ID即可查询完整的商品信息
- 支持查看商品图片、价格、颜色、成分等详细信息

### PDF文件解析
- 支持上传PDF文件
- 自动解析PDF中的商品信息并保存到数据库

### 商品卖点生成
- 输入商品ID和图片（可选）
- 自动生成中英文卖点描述
- 提取三个关键卖点

### 卖点标题生成
- 输入商品ID和描述（可选）
- 自动生成中英文标题

## 注意事项

- 确保数据库目录存在并有正确的访问权限
- PDF文件解析需要确保文件格式正确
- 商品ID需要与数据库中的记录匹配

## 技术支持

如有问题或建议，请联系项目维护者。
