from io import BytesIO
import sys

import numpy as np
import requests
# print(sys.path)
sys.path.append("/data/data/luosy/project/sku_search")
import time
import os
from PIL import Image
import uuid
from  utils.prompt import *
from utils.llm import *
import json
from utils.conf import *
import re


history_list=[]

plugins = {
    "ch_en_selling_points":get_ch_en_selling_points,
    "en_ch_selling_points":get_en_ch_selling_points,
    "ch_en_selling_title":get_ch_en_selling_title,
    "en_ch_selling_points_his":get_en_ch_selling_points_his,
    "TextControl_his":TextControl_his
}

def search_json_files(filename):
    directory = "./database/meta"
    data = {}
    for file in os.listdir(directory):
        if file.endswith('.json') and filename in file:
            with open(os.path.join(directory, file), 'r') as f:
                data = json.load(f)
    if data =={}:
        return None,"暂无数据","暂无数据","暂无数据","暂无数据","暂无数据"
    return data["商品图像"], data["价格"], data["色号"], data["成分"], data["关键词"], data["商品细节"]


def is_valid_response(response_dict):
    """
    检查响应是否是有效的JSON格式且包含所需字段
    """
    try:
        # response_dict = json.loads(response) 
        required_fields = ["服装描述（中文）", "服装描述（英文）", "3个关键点（英文）"]
        return all(field in response_dict for field in required_fields)
    except Exception as e:
        return False



def convert_to_dict(s):
    s= s.replace('json','').replace('```','').strip() if 'json' in s else s
    s=json.loads((s))
    return s


def extract_response_values(response_dict):
    """
    从响应中提取各个字段的值
    Args:
        response: JSON格式的响应字符串
    Returns:
        tuple: (中文描述, 英文描述, 关键点)
    """
    try:
        # response_dict = json.loads(response)
        cn_desc = response_dict.get("服装描述（中文）", "")
        en_desc = response_dict.get("服装描述（英文）", "")
        key_points = response_dict.get("3个关键点（英文）", "")
        return cn_desc, en_desc, key_points
    except Exception as e:
        return "", "", ""

# def read_image(im_data):
#     out_image=None
#     if isinstance(im_data, str):
#         if im_data.startswith("http"):
#             headers = {
#                 'User-Agent': 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36 QIHU 360SE'
#             }
#             im_path = BytesIO(requests.get(im_data, headers=headers).content)
#         else:
#             im_path = im_data
#         out_image = Image.open(im_path)
#     elif isinstance(im_data, Image.Image):
#         out_image = im_data
#     elif isinstance(im_data, np.ndarray):
#         out_image = Image.fromarray(im_data)

#     return out_image  # make a batch of image, shape


def format_history(strings, indent="    "):
    result = ""
    for i, string in enumerate(strings, start=1):
        # 拼接序号、缩进和字符串，并添加换行符
        result += f"{indent}{i}. {string}\n"
    return result

def get_history():
    global history_list
    if len(history_list)==0:
        history=''
    else:
        history=format_history(history_list)
    return history
def add_history(input,max_num=20):
    global history_list
    text = re.split(r'[,\.\!\?\;\:]+', input)
    text=text[0].strip()
    history_list.insert(0, text)
    if len(history_list)>max_num:
        history_list=history_list[:max_num]


def generate_text(plm_info,img,graphic_label=None,method="en_ch_selling_points_his",plat="ali",model_name="mm_tyqw"):
    # img=read_image(img)
    his=get_history()
    if graphic_label:
        plm_info+="\n以下是该衣服的关键点:"+graphic_label
    if plat=="ali":
        key=ali_ky
        model=ali_model[model_name]
        print('3333333333333')
    else:
        key=doubao_ky
        model=doubao_model[model_name]
    usrp = plugins[method](plm_info,his)
    llm=llm_request(*key,model)

    for _ in range(3):
        try:
            result = llm.llm_mm_request(usrp,img)
            result=convert_to_dict(result)
            if is_valid_response(result):
                ch,en,kw=extract_response_values(result)
                add_history(en)
                break
        except Exception as e:
            print(f"Attempt failed with error: {str(e)}")

    # result={"descr":en,"keywords":kw}
    return ch,en,kw


def generate_text_new(plm_info,img,graphic_label=None,method="TextControl_his",plat="ali",model_name1="mm_tyqw",model_name2="text_qwen"):

    his=get_history()
    if graphic_label:
        plm_info+="\n以下是该衣服的关键点:"+graphic_label
    if plat=="ali":
        key=ali_ky
        model1=ali_model[model_name1]
        model2=ali_model[model_name2]
    else:
        key=doubao_ky
        model=doubao_model[model_name1]
    sim_prompt="如果图片里有文字的话，请结合图片里的衣服和文本信息进行描述一下衣服,如果图片是下半身就只描述下半身，如果是上半身就只描述上半身，全身就描述全身的衣服，除衣服之外的配饰不要描述，还要具体到衣服的风格"
    llm_mm=llm_request(*key,model1)
    llm_lm=llm_request(*key,model2)
    res1 = llm_mm.llm_mm_request(sim_prompt,img)
    print(res1)
    sys_prompt,usr_prompt = plugins[method](res1,his)
    for _ in range(3):
        try:
            result=llm_lm.llm_text_request(usr_prompt,sys_prompt)
            result=convert_to_dict(result)
            # print(result)
            if is_valid_response(result):
                ch,en,kw=extract_response_values(result)
                add_history(en)
                break
        except Exception as e:
            print(f"Attempt failed with error: {str(e)}")

    # result={"descr":en,"keywords":kw}
    return ch,en,kw
def process_sellpoint(id,image=None,info=""):
    if len(id) == 9:
        id_image,id_price, id_color, id_ingredient, id_selling_point, id_details=search_json_files(id)
        print(id_image,id_price, id_color, id_ingredient, id_selling_point, id_details)

    else:
        id_image,id_price, id_color, id_ingredient, id_selling_point, id_details=None,None,None,None,None,None

    info=id_details+info if id_details else info
    if image == None and id_image != None:
        image=Image.open(id_image)

    ch_sen,en_sen,key_point=generate_text(info,image)
    return ch_sen,en_sen,key_point,id_image,id_price, id_color, id_ingredient, id_selling_point, id_details


def gen_title(info,tags=None,referencr_title=None,method="ch_en_selling_title",plat="ali",model_name="text_dsv3"):
    
    if tags:
        tags_sen=",".join(tags)
        info="以下是该衣服的关键点:"+tags_sen
    if referencr_title:
        info="\n请以这条标题样例的结构作为借鉴来写这条标题："+referencr_title
    sysp,usrp = plugins[method](info)
    if plat=="ali":
        key=ali_ky
        model=ali_model[model_name]
    else:
        key=doubao_ky
        model=doubao_model[model_name]
    
    llm=llm_request(*key,model)
    res=llm.llm_text_request(usrp,sysp)
    res_dict = json.loads(res)
    return res_dict["en_tile"],res_dict["ch_title"]


def process_title(id,info=None,method="ch_en_selling_title"):
    info_new=None
    if len(id) == 9:
        info_new=process_sellpoint(id)[1]
    if info_new ==None and info !=None:
        info_new=info
    en_tile,ch_title=gen_title(info_new)
    return en_tile,ch_title
if __name__ == "__main__":
    print(process_sellpoint("","/data/data/luosy/project/sku_search/temp_img/企业微信截图_17439887354277.png","1、16mm平纹香云纱；2、香蕉裤型；3、裤身立体收省；4、后腰包橡筋；5、两侧插袋；两边插袋里面有网布贴袋，一大一小，大的可套手机，小的可套耳机或卡片；6、真门牌，大溪地贝壳扣"))
    # print(process_sellpoint("1E2L1D290"))

#     from PIL import Image
#     img1=Image.open("/data/data/luosy/project/sku_search/temp_img/企业微信截图_17372766091671.png")

#     ch_sen,en_sen,key_point,id_image,id_price, id_color, id_ingredient, id_selling_point, id_details=generate_text("",img1,"""-With elastic waistband
# -With hairband
# -X-line fit
# 1.腰部橡筋 2.袖子橡
# 筋 3.前中绳子可调
# 节大小""")
#     print(len(en_sen),end=" ")
#     print(ch_sen,en_sen,key_point)
#     ###############################
#     img2=Image.open("/data/data/luosy/project/sku_search/temp_img/企业微信截图_17389065463149[1](1).png")

#     ch_sen,en_sen,key_point,id_image,id_price, id_color, id_ingredient, id_selling_point, id_details=generate_text("",img2,"""-Washable wool
# -Unisex
# -With silver threads
# 1.后中开衩；2.双扣可调节袖袢；3.暗门筒设计，天然果实扣；4.可水洗羊毛含银葱人字纹面料；5.里面左右两侧均有内袋，左侧最外层内袋是手机袋，防丢失""")
#     print(len(en_sen),end=" ")
#     print(ch_sen,en_sen,key_point)
#     ###############################
#     img3=Image.open("/data/data/luosy/project/sku_search/temp_img/企业微信截图_17392379937637.png")

#     ch_sen,en_sen,key_point,id_image,id_price, id_color, id_ingredient, id_selling_point, id_details=generate_text("",img3,"""-Acetate
# -With pockets
# -Workwear
# 1.描述二醋酸面料:2.扣子为镶钻布包扣;3.半裙后腰包橡筋;4.半裙有
# 侧插袋;5.半裙有侧开隐形拉链，这是两件套套装""")
#     print(len(en_sen),end=" ")
#     print(ch_sen,en_sen,key_point)