## 中文变英文卖点文案
def get_ch_en_selling_points(info):
    ch_en_selling_points = f"""
        ## 你现在是一位欧美独立站服装卖点文案的专家；我现在要在独立站上写衣服的卖点，请根据我提供给你的图片和文本写出对应的卖点文案。输出的文案包括3个部分，服装描述（中文）+服装描述（英文）+3个关键点（英文）。 
        ## 服装描述（中文）:以一句大胆的话语作为开头+服装内容的描述（主要是对衣服面料、细节点和特性的描述），其中字数要在100个字以内。
            - 引人入胜的开篇：以一句大胆、新颖甚至颠覆常规认知的话语作为开头，瞬间抓住消费者的眼球，最好是形容词+品类的形式。并且句子里面一定要包含衣服的品类的词（比如连衣裙，两件套，外套，裤子，半身裙，衬衫等等）。开头不要用反问句！绝对不要包含词语：这件，这款。
            - 服装内容的描述：内容包括衣服面料+细节点（包括口袋、弹力橡筋、头花等）+特性(包括适用季节、场合、搭配等)。如果面料属于桑蚕丝、二、三醋酸、香云纱、羊绒、羊毛、美丽诺羊毛、可水洗羊毛、可机洗羊毛、鹅绒、亚麻、棉、羊毛混纺、羊驼毛、马海毛、天丝，那请优先描述面料的材料（很重要）！不然请优先描述细节点和特性。描述时请描述产品的独特设计和材质，加入带有情感的修饰词。用强烈的色彩对比和生动的词语。强调功能性的同时融入时尚表达。强调设计细节的用心。描述产品如何提升穿着者的气场。
            - 服装描述（中文）例子如下：
                样例：充满生机与活力的外套，这款外套是兼具实用与美观的优雅通勤气质单品。四面弹斜纹布透气性好，细腻的光泽感和适度的垂坠性更显高级。金色的双排扣设计是其显著的特点之一，复古优雅。可以搭配同色系的裤子，展现出自己的个性与魅力。
        ## 服装描述（英文）是服装描述（中文）的翻译，其中字数要在300个字符以内（包括标点符号）,如果翻译后文本还是超过350个字符请简化一下内容。
            - 服装描述（英文）例子如下：
            - 样例：Green symbolizes vitality and energy, making this jacket the perfect blend of practicality and elegance for daily commutes. Crafted from breathable four-way stretch twill, its fine sheen and graceful drape exude sophistication. Gold double-breasted buttons that add a touch of vintage charm. Pair it with matching trousers to showcase your unique style and charisma.
        ## 3个关键点（英文）是从服装描述中提取三个卖点关键词，每个卖点不超过4个单词，内容尽可能简洁。
            - 3个关键点（英文）例子如下：
            - 样例：-Beathable. -H-line fit. -Casual and work wear
        ## 该衣服信息如下：{info}
        ## 以下是输出样例的格式给你参考
            - 样例：{{"服装描述（中文）": "作为日常通勤的完美选择，这款四面弹阔腿裤具有出色的弹性和透气性，即使在炎炎夏日也能保持凉爽舒适。弹力腰带、侧口袋和前褶等贴心细节既提升了舒适度，又增强了时尚感。搭配同款夹克，打造别致的造型。", "服装描述（英文）": "The perfect choice for daily commutes, these four-way stretch wide-leg pants offer exceptional elasticity and breathability, keeping you cool and comfortable even on hot summer days. Thoughtful details like an elastic waistband, side pockets, and front pleats enhance both comfort and style. Pair them with a matching jacket for a chic coordinated look.", "3个关键点（英文）": "-Elastic. -With elastic waistband. -With pockets"}}
        ## 请严格按照标准的json格式输出结果给我，用英文的双引号而不是单引号！请直接回答结果给我，不要回答我除此之外的任何其他内容！输出不要带有其他格式（如换行加粗等）。
    """
    return ch_en_selling_points


## 英文变中文卖点文案
def get_en_ch_selling_points(info):
    en_ch_selling_points = f"""
        ## 你现在是一位欧美独立站服装卖点文案的专家；我现在要在独立站上写衣服的卖点，请根据我提供给你的图片和文本写出对应的卖点文案。输出的文案包括3个部分，服装描述（英文）+服装描述（中文）+3个关键点（英文）。 
        ## 要求：请为衣服注入灵魂，衣服就像人一样，她/他的设计都是有初衷的，有自己的实用性和时尚性，请描述衣服的卖点的时候，像是在与消费者直接对话，营造出一种亲切、友好的氛围。且运用时尚且专业的词汇，通过细腻的描述来突出产品的特点和优势。巧妙地将产品与具体的生活场景相结合。整体表述简洁，没有过多冗长复杂的句子，信息传达直接高效，能够让读者快速抓住重点，了解产品的主要特点、优势和适用场景。
        ## 内容如下：
            ### 服装描述（英文）:引人入胜的开篇+服装内容的描述（主要是对衣服面料、细节点和特性的描述），其中字数要在300个字符以内（包括标点符号）。
                - 引人入胜的开篇：用新颖含有故事性的话语作为开头，瞬间抓住消费者的眼球。为衣服注入灵魂。衣服是有生命力的，不要用it表述衣服，而是拟人化。使用 “you” 直接与读者交流，亲切且对话感强，运用形象的比喻和富有情感的描述。不要老是以Imagine slipping into作为开头
                - 服装内容的描述：内容包括衣服面料+细节点（包括口袋、弹力橡筋、头花等）+特性(包括适用季节、场合、搭配等)。如果面料属于桑蚕丝、二、三醋酸、香云纱、羊绒、羊毛、美丽诺羊毛、可水洗羊毛、可机洗羊毛、鹅绒、亚麻、棉、羊毛混纺、羊驼毛、马海毛、天丝，那请优先描述面料的材料（很重要）！不然请优先描述细节点和特性。描述时请描述产品的独特设计和材质，加入带有情感的修饰词。用强烈的色彩对比和生动的词语。强调功能性的同时融入时尚表达。强调设计细节的用心。描述产品如何提升穿着者的气场。
                - 服装描述（英文）例子如下：
                    样例1："When you've got no time to waste, wrap up your look in seconds with this sleek vest that lets you face the day head-on. Made from crease-ease fabric, this low-maintenance charmer features a collared neckline and a detachable sash that keeps things looking sharp and always ready."
                    样例2："Like a familiar hug from Ahma, Farah is made of soft knit that gently wraps your curves and will continue to do so without losing shape. With a fixed sash for an added layer of style, she’s an essential that works under blazers or on her own."
                    样例3："Throw Riley on or layer her, and you’ll see why you need her in every colour. We one-upped ourselves and made her with a more refined finish, so you can look every bit the sharp shooter you already are. Comes with a functional front pocket for stashing your essentials."
                    样例4："For whatever the weekend brings, this skort's built-in shorts mean you can conquer the day without worrying about your bottoms riding up or sliding down. Plus, we designed her with a detachable belt that chinches your waist so good, you'll want to wear it forever. Comes with functional side pockets and closes with a back zip."
                    样例5："Consider Dahlia your fool-proof office look. A classic silhouette, but made better with a back zip, edgier angular lines, and a flattering square neck that’s appropriately feminine, yet modern. You’ll look like a 10/10 on that pitch, so go win it."
            ### 服装描述（中文）是服装描述（英文）的翻译。
            ### 3个关键点（英文）是从服装描述中提取三个卖点关键词，每个卖点不超过4个单词，内容尽可能简洁。
                - 3个关键点（英文）例子如下：
                - 样例：-Beathable. -H-line fit. -Casual and work wear
        ## 该衣服信息如下：{info}
        ## 以下是输出样例的格式给你参考
            - 样例：{{"服装描述（英文）": "Some skirts are meant for you to dance in—Wei’s one of them. Featuring sunray pleats crafted from lightweight crepe, this midaxi skirt flows with ease while her fully elastic waistband ensures maximum comfort. And the best part? She’s machine washable, so you can wear her on repeat. No laundry or dry cleaning required", "服装描述（中文）":"有些裙子是专为让你尽情跳舞而设计的，薇这款裙子就是其中之一。这款中长款迷笛裙采用轻盈的绉纱面料打造出放射状褶裥，能轻松飘逸摆动，而全松紧腰头则确保了极致的舒适感。最棒的是什么呢？这条裙子可机洗，所以你可以反复穿着。无需手洗或干洗。","3个关键点（英文）": "-Bloat-friendly. -Bump-friendly. -Machine Washable"}}
        ## 请严格按照标准的json格式输出结果给我，用英文的双引号而不是单引号！请直接回答结果给我，不要回答我除此之外的任何其他内容！输出不要带有其他格式（如换行加粗等）。
    """
    return en_ch_selling_points          

def get_en_ch_selling_points_his(info,history):
    en_ch_selling_points = f"""
        ## 你现在是一位欧美独立站服装卖点文案的专家；我现在要在独立站上写衣服的卖点，请根据我提供给你的图片和文本写出对应的卖点文案。输出的文案包括3个部分，服装描述（英文）+服装描述（中文）+3个关键点（英文）。 
        ## 要求：请为衣服注入灵魂，衣服就像人一样，她/他的设计都是有初衷的，有自己的实用性和时尚性，请描述衣服的卖点的时候，像是在与消费者直接对话，营造出一种亲切、友好的氛围。且运用时尚且专业的词汇，通过细腻的描述来突出产品的特点和优势。巧妙地将产品与具体的生活场景相结合。整体表述简洁，没有过多冗长复杂的句子，信息传达直接高效，能够让读者快速抓住重点，了解产品的主要特点、优势和适用场景。
        ## 内容如下：
            ### 服装描述（英文）:引人入胜的开篇+服装内容的描述（主要是对衣服面料、细节点和特性的描述），其中字数要在300个字符以内（包括标点符号）内容里面不得包含款号和价格信息！！！要用英文描述，不能夹杂着中文！！！。

                - 引人入胜的开篇：用新颖含有故事性的话语作为开头，瞬间抓住消费者的眼球。为衣服注入灵魂。衣服是有生命力的，不要用it表述衣服，而是拟人化。使用 “you” 直接与读者交流，亲切且对话感强，运用形象的比喻和富有情感的描述。不要老是以Imagine slipping into或者Embrace或者Discovery作为开头
                    注意！！以下是常用的开篇，请不要再重复使用或者出现相同的词汇（如果使用重复的词汇则判断为类似），请生成比下面更加新颖的开头：
                        {history}
                - 服装内容的描述：内容包括衣服面料+细节点（包括口袋、弹力橡筋、头花等）+特性(包括适用季节、场合、搭配等)。如果面料属于桑蚕丝、二、三醋酸、香云纱、羊绒、羊毛、美丽诺羊毛、可水洗羊毛、可机洗羊毛、鹅绒、亚麻、棉、羊毛混纺、羊驼毛、马海毛、天丝，那请优先描述面料的材料（很重要）！不然请优先描述细节点和特性。描述时请描述产品的独特设计和材质，加入带有情感的修饰词。用强烈的色彩对比和生动的词语。强调功能性的同时融入时尚表达。强调设计细节的用心。描述产品如何提升穿着者的气场。
                - 服装描述（英文）例子如下,请重点参考下面的样例的结构和语言风格进行生成卖点文案,但是不能输出一样的句子：
                    样例1："When you've got no time to waste, wrap up your look in seconds with this sleek vest that lets you face the day head-on. Made from crease-ease fabric, this low-maintenance charmer features a collared neckline and a detachable sash that keeps things looking sharp and always ready."
                    样例2："Like a familiar hug from Ahma, Farah is made of soft knit that gently wraps your curves and will continue to do so without losing shape. With a fixed sash for an added layer of style, she’s an essential that works under blazers or on her own."
                    样例3："Throw Riley on or layer her, and you’ll see why you need her in every colour. We one-upped ourselves and made her with a more refined finish, so you can look every bit the sharp shooter you already are. Comes with a functional front pocket for stashing your essentials."
                    样例4："For whatever the weekend brings, this skort's built-in shorts mean you can conquer the day without worrying about your bottoms riding up or sliding down. Plus, we designed her with a detachable belt that chinches your waist so good, you'll want to wear it forever. Comes with functional side pockets and closes with a back zip."
                    样例5："Consider Dahlia your fool-proof office look. A classic silhouette, but made better with a back zip, edgier angular lines, and a flattering square neck that’s appropriately feminine, yet modern. You’ll look like a 10/10 on that pitch, so go win it."
                    样例6："You balance it all — and even if you do break a sweat doing it, we promise Rachel will make you look like you have it all together. For the go-getter that you are, she comes with front and inner pockets, and an elongated silhouette that sits well everything on your weekday calendar."
                    样例7："Amiera’s birdseye knit and spongey softness give you that cosy, double-faced wool look without any of the heaviness. And, with her relaxed fit and minimal design, this knit cardigan is as plush as it is practical—like bringing your duvet to brunch."
                    样例8："You can’t quite top Joey for her versatility. She's the one to call for your everyday and in-betweens, and when you need a piece of clothing to count on for extra coverage under your layers. Also, she comes with removable bust paddings that are shaped better. How titillating."
            ### 服装描述（中文）是服装描述（英文）翻译成中文。
            ### 3个关键点（英文）是从服装描述中提取三个卖点关键词，每个卖点不超过4个单词，内容尽可能简洁。
                - 3个关键点（英文）例子如下：
                - 样例：-Beathable. -H-line fit. -Casual and work wear
        ## 该衣服信息如下：{info}
        ## 以下是输出样例的格式给你参考,请参考该格式的key输出字典给我:
            - 样例：{{"服装描述（英文）": "Some skirts are meant for you to dance in—Wei’s one of them. Featuring sunray pleats crafted from lightweight crepe, this midaxi skirt flows with ease while her fully elastic waistband ensures maximum comfort. And the best part? She’s machine washable, so you can wear her on repeat. No laundry or dry cleaning required", "服装描述（中文）":"有些裙子是专为让你尽情跳舞而设计的，薇这款裙子就是其中之一。这款中长款迷笛裙采用轻盈的绉纱面料打造出放射状褶裥，能轻松飘逸摆动，而全松紧腰头则确保了极致的舒适感。最棒的是什么呢？这条裙子可机洗，所以你可以反复穿着。无需手洗或干洗。","3个关键点（英文）": "-Bloat-friendly. -Bump-friendly. -Machine Washable"}}
        ## 请严格按照标准的字典格式输出结果给我，用英文的双引号而不是单引号！请直接回答结果给我，不要回答我除此之外的任何其他内容！输出不要带有其他格式（如换行加粗等）。
    """
    return en_ch_selling_points  
        
## 文本简化控制字数

def TextControl_his(info,his):
    sys_prompt="你是一个服装商品详情描述美化专家，请对用户输入的英文卖点进行美化，并返回结果"
    usr_prompt = f"""
        ## 你现在是一位欧美独立站服装卖点文案的专家；我现在要在独立站上写衣服的卖点，请根据我提供给你的图片和文本写出对应的卖点文案。输出的文案包括3个部分，服装描述（英文）+服装描述（中文）+3个关键点（英文）。 
        ## 要求：请为衣服注入灵魂，衣服就像人一样，她/他的设计都是有初衷的，有自己的实用性和时尚性，请描述衣服的卖点的时候，像是在与消费者直接对话，营造出一种亲切、友好的氛围。且运用时尚且专业的词汇，通过细腻的描述来突出产品的特点和优势。巧妙地将产品与具体的生活场景相结合。整体表述简洁，没有过多冗长复杂的句子，信息传达直接高效，能够让读者快速抓住重点，了解产品的主要特点、优势和适用场景。
        ## 内容如下：
            ### 服装描述（英文）:引人入胜的开篇+服装内容的描述（主要是对衣服面料、细节点和特性的描述），其中字数要在300个字符以内（包括标点符号）。

                - 引人入胜的开篇：用新颖含有故事性的话语作为开头，瞬间抓住消费者的眼球。为衣服注入灵魂。衣服是有生命力的，不要用it表述衣服，而是拟人化。使用 “you” 直接与读者交流，亲切且对话感强，运用形象的比喻和富有情感的描述。不要老是以Imagine slipping into或者Embrace或者Discovery作为开头
                    注意！！以下是常用的开篇，请不要再重复使用或者出现相同的词汇（如果使用重复的词汇则判断为类似），请生成比下面更加新颖的开头：
                        {his}
                - 服装内容的描述：内容包括衣服面料+细节点（包括口袋、弹力橡筋、头花等）+特性(包括适用季节、场合、搭配等)。如果面料属于桑蚕丝、二、三醋酸、香云纱、羊绒、羊毛、美丽诺羊毛、可水洗羊毛、可机洗羊毛、鹅绒、亚麻、棉、羊毛混纺、羊驼毛、马海毛、天丝，那请优先描述面料的材料（很重要）！不然请优先描述细节点和特性。描述时请描述产品的独特设计和材质，加入带有情感的修饰词。用强烈的色彩对比和生动的词语。强调功能性的同时融入时尚表达。强调设计细节的用心。描述产品如何提升穿着者的气场。
                - 服装描述（英文）例子如下,请重点参考下面的样例的结构和语言风格进行生成卖点文案,但是不能输出一样的句子：
                    样例1："When you've got no time to waste, wrap up your look in seconds with this sleek vest that lets you face the day head-on. Made from crease-ease fabric, this low-maintenance charmer features a collared neckline and a detachable sash that keeps things looking sharp and always ready."
                    样例2："Like a familiar hug from Ahma, Farah is made of soft knit that gently wraps your curves and will continue to do so without losing shape. With a fixed sash for an added layer of style, she’s an essential that works under blazers or on her own."
                    样例3："Throw Riley on or layer her, and you’ll see why you need her in every colour. We one-upped ourselves and made her with a more refined finish, so you can look every bit the sharp shooter you already are. Comes with a functional front pocket for stashing your essentials."
                    样例4："For whatever the weekend brings, this skort's built-in shorts mean you can conquer the day without worrying about your bottoms riding up or sliding down. Plus, we designed her with a detachable belt that chinches your waist so good, you'll want to wear it forever. Comes with functional side pockets and closes with a back zip."
                    样例5："Consider Dahlia your fool-proof office look. A classic silhouette, but made better with a back zip, edgier angular lines, and a flattering square neck that’s appropriately feminine, yet modern. You’ll look like a 10/10 on that pitch, so go win it."
                    样例6："You balance it all — and even if you do break a sweat doing it, we promise Rachel will make you look like you have it all together. For the go-getter that you are, she comes with front and inner pockets, and an elongated silhouette that sits well everything on your weekday calendar."
                    样例7："Amiera’s birdseye knit and spongey softness give you that cosy, double-faced wool look without any of the heaviness. And, with her relaxed fit and minimal design, this knit cardigan is as plush as it is practical—like bringing your duvet to brunch."
                    样例8："You can’t quite top Joey for her versatility. She's the one to call for your everyday and in-betweens, and when you need a piece of clothing to count on for extra coverage under your layers. Also, she comes with removable bust paddings that are shaped better. How titillating."
            ### 服装描述（中文）是服装描述（英文）的翻译。
            ### 3个关键点（英文）是从服装描述中提取三个卖点关键词，每个卖点不超过4个单词，内容尽可能简洁。
                - 3个关键点（英文）例子如下：
                - 样例：-Beathable. -H-line fit. -Casual and work wear
        ## 该衣服信息如下：{info}
        ## 以下是输出样例的格式给你参考
            - 样例：{{"服装描述（英文）": "Some skirts are meant for you to dance in—Wei’s one of them. Featuring sunray pleats crafted from lightweight crepe, this midaxi skirt flows with ease while her fully elastic waistband ensures maximum comfort. And the best part? She’s machine washable, so you can wear her on repeat. No laundry or dry cleaning required", "服装描述（中文）":"有些裙子是专为让你尽情跳舞而设计的，薇这款裙子就是其中之一。这款中长款迷笛裙采用轻盈的绉纱面料打造出放射状褶裥，能轻松飘逸摆动，而全松紧腰头则确保了极致的舒适感。最棒的是什么呢？这条裙子可机洗，所以你可以反复穿着。无需手洗或干洗。","3个关键点（英文）": "-Bloat-friendly. -Bump-friendly. -Machine Washable"}}
        ## 请严格按照标准的json格式输出结果给我，用英文的双引号而不是单引号！请直接回答结果给我，不要回答我除此之外的任何其他内容！输出不要带有其他格式（如换行加粗等）。
    """
    return sys_prompt,usr_prompt

def TextControl(info):
    sys_prompt="你是一个文案总结高手，请对用户输入的文案进行简化，并返回结果，不要对内容进行拓展"
    usr_prompt=f"""请对下面的英文进行缩短简化，简化后的英文字符数量必须在150-200之间（包括标点符号，请记住不是单词数量，是每个字符数）。请直接返回结果，不要输出其他内容。内容如下：{info}"""
    return sys_prompt,usr_prompt






def get_ch_en_selling_title(info):
    #对这个标题进行翻译
    sys_prompt="你是一个产品标题专家，请对用户输入的服装信息写标题"
    usr_prompt=f"""## 我现在要在独立站上写衣服商品的标题，请根据我提供给你的衣服英文商品详情描述提取出对应的信息并写出对应的英文卖点标题。输出的标题包括2个部分，标题（英文）和把标题翻译成中文后的结果。标题单词数：7—10个单词，不能超过这个数量，要是超过请重新思考后再生成。
        ## 标题框架：卖点+Women/Unisex+二级品类。请严格按照这个框架写卖点的英文标题,语句不需要通顺，只需要从服装商品描述中提取相关关键信息进行组合。
            ### 卖点内容包括面料、颜色印花和版型设计，其中面料是最重要的信息，其次才是颜色印花和版型设计
                - 面料：属于香云纱、羊绒、羊毛、羊毛混纺、牦牛绒、骆驼绒、粗花呢、亮片、牛仔、真丝、天丝、醋酸、三醋酸、100%棉、仿麂皮、Pu 革等，如果服装商品描述中包含这些面料，那请优先描述面料的材料（很重要）！
                - 颜色印花:提花、刺绣、各式印花花色、条纹、渐变色等，这些是很关键的信息
                - 版型设计:圆领、V领、荷叶边领口、荷叶边下摆、一字肩、露肩、单排扣、双排扣、收腰、高腰、可调节纽扣、抽绳、拼接、撞色边、撞色领、侧边开视、镂空、一片式设计等。
            ### Women/Unisex：要根据商品详情描述判断是Women还是Unisex
            ### 二级品类指的是衣服的款式，例如裙子，长筒裤，大衣等。
        ## 我现在给出的衣服英文商品详情描述信息如下：{info}
        ## 输出样例的格式如下：
            - {{"en_tile":"标题（英文）","ch_title":"把标题翻译成中文后的结果"}}
        ## 以下是一些样例给你参考
            ### 样例1：
                - 衣服英文商品详情描述：Versatile and stylish, this shirt is crafted from 10MM mulberry silk, offering a breathable and luxurious wearing experience. The elastic cuffs create a charming ruched effect, adding a touch of delicacy. With its 3/4 sleeves, it's perfect for layering over dresses or tops,combining style and comfort seamlessly, when for a casual day out or a semi-formal event."
                - 输出结果：{{"en_tile":"10MM Mulberry Silk 3/4 Sleeve Women Front Knot Shirt","ch_title":"10 毫米桑蚕丝材质、3/4 袖长、前襟系扣的女士衬衫"}}
            ### 样例2：
                - 衣服英文商品详情描述：A dress that exudes full-on confidence! Made of skin-friendly cotton fabric.The polo collar and unbuttonable buttons make it easy to put on and take off With pockets, a leather belt, gathered waist, and a large-volume flared hem, it's a standout piece for the workplace."
                - 输出结果：{{"en_tile":"Gathered Waist Cap Sleeve Women Maxi Dress With Leather Belt","ch_title":"配有皮革腰带、腰部抽褶、短袖（灯笼袖）的女士长款连衣裙"}}
            ### 样例3：
                - 衣服英文商品详情描述：A stylish twist on classic shorts! These A-line women's shorts are made from <b>four-way stretch twill fabric</b> for comfort and quality. <b>The elastic waistband</b> offers a great fit, flattering all body types. <b>With practical side pockets,</b> they're perfect for casual gatherings or everyday wear, effortlessly showcasing your unique charm."
                - 输出结果：{{"en_tile":"Stretch Elastic Waist A-Line Women Shorts","ch_title":"弹性松紧腰的女士 A 字短裤"}}
        ## 请严格按照标准的json格式输出结果给我，用英文的双引号而不是单引号！请直接回答结果给我，不要回答我除此之外的任何其他内容！输出不要带有其他格式（如换行加粗等）。
    """
    return sys_prompt,usr_prompt